Base64OutputStream (Apache Commons Codec 1.22.0 API)
Description: declaration: package: org.apache.commons.codec.binary, class: Base64OutputStream

Package org.apache.commons.codec.binary

# Class Base64OutputStream

java.lang.Object
java.io.OutputStream
java.io.FilterOutputStream
org.apache.commons.codec.binary.BaseNCodecOutputStream<Base64,Base64OutputStream,Base64OutputStream.Builder>
org.apache.commons.codec.binary.Base64OutputStream

All Implemented Interfaces:
  `Closeable`, `Flushable`, `AutoCloseable`

public class Base64OutputStream extends BaseNCodecOutputStream<Base64,Base64OutputStream,Base64OutputStream.Builder>
Provides Base64 encoding in a streaming fashion (unlimited size). When encoding the default lineLength is 76 characters and the default lineEnding is CRLF, but these can be overridden by using the appropriate constructor.

The default behavior of the Base64OutputStream is to ENCODE, whereas the default behavior of the Base64InputStream is to DECODE. But this behavior can be overridden by using a different constructor.

This class implements section 6.8. Base64 Content-Transfer-Encoding from RFC 2045 Multipurpose Internet Mail Extensions (MIME) Part One: Format of Internet Message Bodies by Freed and Borenstein.

Since this class operates directly on byte streams, and not character streams, it is hard-coded to only encode/decode character encodings which are compatible with the lower 127 ASCII chart (ISO-8859-1, Windows-1252, UTF-8, etc).

Note: It is mandatory to close the stream after the last byte has been written to it, otherwise the final padding will be omitted and the resulting data will be incomplete/inconsistent.

You can set the decoding behavior when the input bytes contain leftover trailing bits that cannot be created by a valid encoding. These can be bits that are unused from the final character or entire characters. The default mode is lenient decoding.

- Lenient: Any trailing bits are composed into 8-bit bytes where possible. The remainder are discarded.
- Strict: The decoding will raise an `IllegalArgumentException` if trailing bits are not part of a valid encoding. Any unused bits from the final character must be zero. Impossible counts of entire final characters are not allowed.

When strict decoding is enabled it is expected that the decoded bytes will be re-encoded to a byte array that matches the original, i.e. no changes occur on the final character. This requires that the input bytes use the same padding and alphabet as the encoder.

Since:
  1.4
See Also:
  - `Base64`
  - RFC 2045

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `Base64OutputStream.Builder`
  Builds instances of Base32InputStream.

  ## Nested classes/interfaces inherited from class org.apache.commons.codec.binary.BaseNCodecOutputStream

  `BaseNCodecOutputStream.AbstractBuilder<T,C extends BaseNCodec,B extends BaseNCodecOutputStream.AbstractBuilder<T,C,B>>`

- ## Field Summary

  ### Fields inherited from class java.io.FilterOutputStream

  `out`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Base64OutputStream(OutputStream outputStream)`
  Constructs a Base64OutputStream such that all data written is Base64-encoded to the original provided OutputStream.
  `Base64OutputStream(OutputStream outputStream, boolean encode)`
  Deprecated.
  Use `builder()` and `Base64OutputStream.Builder`.
  `Base64OutputStream(OutputStream outputStream, boolean encode, int lineLength, byte[] lineSeparator)`
  Deprecated.
  Use `builder()` and `Base64OutputStream.Builder`.
  `Base64OutputStream(OutputStream outputStream, boolean encode, int lineLength, byte[] lineSeparator, CodecPolicy decodingPolicy)`
  Deprecated.
  Use `builder()` and `Base64OutputStream.Builder`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Base64OutputStream.Builder`
  `builder()`
  Constructs a new Builder.

  ### Methods inherited from class org.apache.commons.codec.binary.BaseNCodecOutputStream

  `close, eof, flush, isStrictDecoding, write, write`

  ### Methods inherited from class java.io.FilterOutputStream

  `write`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### Base64OutputStream

    public Base64OutputStream(OutputStream outputStream)
    Constructs a Base64OutputStream such that all data written is Base64-encoded to the original provided OutputStream.
    Parameters:
      `outputStream` - OutputStream to wrap.

  - ### Base64OutputStream

    @Deprecated public Base64OutputStream(OutputStream outputStream, boolean encode)
    Deprecated.
    Use `builder()` and `Base64OutputStream.Builder`.
    Constructs a Base64OutputStream such that all data written is either Base64-encoded or Base64-decoded to the original provided OutputStream.
    Parameters:
      `outputStream` - OutputStream to wrap.
      `encode` - true if we should encode all data written to us, false if we should decode.

  - ### Base64OutputStream

    @Deprecated public Base64OutputStream(OutputStream outputStream, boolean encode, int lineLength, byte[] lineSeparator)
    Deprecated.
    Use `builder()` and `Base64OutputStream.Builder`.
    Constructs a Base64OutputStream such that all data written is either Base64-encoded or Base64-decoded to the original provided OutputStream.
    Parameters:
      `outputStream` - OutputStream to wrap.
      `encode` - true if we should encode all data written to us, false if we should decode.
      `lineLength` - If doEncode is true, each line of encoded data will contain lineLength characters (rounded down to the nearest multiple of 4). If lineLength <= 0, the encoded data is not divided into lines. If doEncode is false, lineLength is ignored.
      `lineSeparator` - If doEncode is true, each line of encoded data will be terminated with this byte sequence (for example \r\n). If lineLength <= 0, the lineSeparator is not used. If doEncode is false lineSeparator is ignored.

  - ### Base64OutputStream

    @Deprecated public Base64OutputStream(OutputStream outputStream, boolean encode, int lineLength, byte[] lineSeparator, CodecPolicy decodingPolicy)
    Deprecated.
    Use `builder()` and `Base64OutputStream.Builder`.
    Constructs a Base64OutputStream such that all data written is either Base64-encoded or Base64-decoded to the original provided OutputStream.
    Parameters:
      `outputStream` - OutputStream to wrap.
      `encode` - true if we should encode all data written to us, false if we should decode.
      `lineLength` - If doEncode is true, each line of encoded data will contain lineLength characters (rounded down to the nearest multiple of 4). If lineLength <= 0, the encoded data is not divided into lines. If doEncode is false, lineLength is ignored.
      `lineSeparator` - If doEncode is true, each line of encoded data will be terminated with this byte sequence (for example \r\n). If lineLength <= 0, the lineSeparator is not used. If doEncode is false lineSeparator is ignored.
      `decodingPolicy` - The decoding policy.
    Since:
      1.15

- ## Method Details

  - ### builder

    public static Base64OutputStream.Builder builder()
    Constructs a new Builder.
    Returns:
      a new Builder.